"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
function _export(target, all) {
    for(var name in all)Object.defineProperty(target, name, {
        enumerable: true,
        get: all[name]
    });
}
_export(exports, {
    PothosPrismaUtilsPlugin: function() {
        return PothosPrismaUtilsPlugin;
    },
    default: function() {
        return _default;
    }
});
require("./global-types");
require("./schema-builder");
const _core = /*#__PURE__*/ _interop_require_wildcard(require("@pothos/core"));
_export_star(require("./types"), exports);
function _define_property(obj, key, value) {
    if (key in obj) {
        Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
        });
    } else {
        obj[key] = value;
    }
    return obj;
}
function _export_star(from, to) {
    Object.keys(from).forEach(function(k) {
        if (k !== "default" && !Object.prototype.hasOwnProperty.call(to, k)) {
            Object.defineProperty(to, k, {
                enumerable: true,
                get: function() {
                    return from[k];
                }
            });
        }
    });
    return from;
}
function _getRequireWildcardCache(nodeInterop) {
    if (typeof WeakMap !== "function") return null;
    var cacheBabelInterop = new WeakMap();
    var cacheNodeInterop = new WeakMap();
    return (_getRequireWildcardCache = function(nodeInterop) {
        return nodeInterop ? cacheNodeInterop : cacheBabelInterop;
    })(nodeInterop);
}
function _interop_require_wildcard(obj, nodeInterop) {
    if (!nodeInterop && obj && obj.__esModule) {
        return obj;
    }
    if (obj === null || typeof obj !== "object" && typeof obj !== "function") {
        return {
            default: obj
        };
    }
    var cache = _getRequireWildcardCache(nodeInterop);
    if (cache && cache.has(obj)) {
        return cache.get(obj);
    }
    var newObj = {
        __proto__: null
    };
    var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor;
    for(var key in obj){
        if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) {
            var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null;
            if (desc && (desc.get || desc.set)) {
                Object.defineProperty(newObj, key, desc);
            } else {
                newObj[key] = obj[key];
            }
        }
    }
    newObj.default = obj;
    if (cache) {
        cache.set(obj, newObj);
    }
    return newObj;
}
const pluginName = 'prismaUtils';
const _default = pluginName;
function normalizeInputObject(object, nullableFields) {
    if (!object) {
        return object;
    }
    if (typeof object !== 'object') {
        return object;
    }
    if (Array.isArray(object)) {
        return object.map((o)=>normalizeInputObject(o, nullableFields));
    }
    const mapped = {};
    for (const key of Object.keys(object)){
        mapped[key] = !nullableFields.has(key) && object[key] === null ? undefined : object[key];
    }
    return mapped;
}
class PothosPrismaUtilsPlugin extends _core.BasePlugin {
    onOutputFieldConfig(fieldConfig) {
        const argMappings = (0, _core.mapInputFields)(fieldConfig.args, this.buildCache, (inputField)=>{
            var _inputType_extensions;
            const inputType = this.buildCache.getTypeConfig((0, _core.unwrapInputFieldType)(inputField.type));
            if ((_inputType_extensions = inputType.extensions) === null || _inputType_extensions === void 0 ? void 0 : _inputType_extensions.pothosPrismaInput) {
                var _inputType_extensions1, _inputType_extensions2;
                return typeof ((_inputType_extensions1 = inputType.extensions) === null || _inputType_extensions1 === void 0 ? void 0 : _inputType_extensions1.pothosPrismaInput) === 'object' ? (_inputType_extensions2 = inputType.extensions) === null || _inputType_extensions2 === void 0 ? void 0 : _inputType_extensions2.pothosPrismaInput : {
                    nullableFields: new Set()
                };
            }
            return null;
        }, this.mappingCache);
        if (!argMappings) {
            return fieldConfig;
        }
        const argMapper = (0, _core.createInputValueMapper)(argMappings, (inputObject, mapping)=>{
            var _mapping_value;
            var _mapping_value_nullableFields;
            return normalizeInputObject(inputObject, (_mapping_value_nullableFields = (_mapping_value = mapping.value) === null || _mapping_value === void 0 ? void 0 : _mapping_value.nullableFields) !== null && _mapping_value_nullableFields !== void 0 ? _mapping_value_nullableFields : new Set());
        });
        var _fieldConfig_argMappers;
        return {
            ...fieldConfig,
            argMappers: [
                ...(_fieldConfig_argMappers = fieldConfig.argMappers) !== null && _fieldConfig_argMappers !== void 0 ? _fieldConfig_argMappers : [],
                (args)=>argMapper(args)
            ]
        };
    }
    constructor(cache){
        super(cache, pluginName), _define_property(this, "mappingCache", new Map());
    }
}
_core.default.registerPlugin(pluginName, PothosPrismaUtilsPlugin);

//# sourceMappingURL=index.js.map